/* Split by HandySAW (splits selected events by scene, using HandySAW DS (tested with version 4.1) )

(c) 2006 altarvic, altarvic@yandex.ru

*/

import Microsoft.Win32;
import System.Diagnostics;
import System.Windows.Forms;
import System.IO;
import Sony.Vegas;

try {

var Params, App, Result, Line, Frames, track, v_evnt, a_evnt, evnt, evnt2, evnt3, NewGroup, Change;
var Done = false;
var tolerance = new Timecode("00:00:00:10");
var Frame: Timecode = new Timecode();
var HandySAW: String = Registry.ClassesRoot.OpenSubKey("TypeLib\\{2ADD2B2C-ACB4-44F4-943D-EF9DC4E51709}\\1.0\\0\\win32").GetValue("") 
var FInfo: FileInfo = new FileInfo(HandySAW);

if (!FInfo.Exists) {
    var OpenDialog = new OpenFileDialog();
    with (OpenDialog) {
      Filter = "HandySawDS.exe|HandySawDS.exe";
      DefaultExt = ".exe";
      CheckPathExists = true;
      CheckFileExists = true;
      AddExtension = true;
    }
    if (DialogResult.OK == OpenDialog.ShowDialog() ) HandySAW = OpenDialog.FileName; else throw "EXIT";
}  

for (track in Vegas.Project.Tracks) if (track.MediaType == MediaType.Video) 
for (evnt in track.Events) if (evnt.Selected) {
    Done = true;
    if (evnt.Takes.Count == 0) continue;
          
    FInfo = new FileInfo(evnt.ActiveTake.MediaPath + ".txt");
    if (!FInfo.Exists) { 
       Change = new FileSystemWatcher(FInfo.DirectoryName, FInfo.Name);
       Change.EnableRaisingEvents = true; 
       App = new Process();
       App.StartInfo.FileName = HandySAW;
       App.StartInfo.Arguments = "/s /x /k /o\"" + FInfo.DirectoryName + "\" /r4 /a\"" + evnt.ActiveTake.MediaPath + "\" ";
       App.Start();
       App.WaitForExit(1800000);
       FInfo.Refresh();
       if (!FInfo.Exists) Change.WaitForChanged(1, 10000);
    }
    
    FInfo.Refresh();
    if (!FInfo.Exists) throw "Not found result file " + FInfo.FullName;
    
    v_evnt = evnt;  
    Result = new StreamReader(FInfo.FullName, System.Text.Encoding.ASCII);
    Frame = new Timecode();
    Line = Result.ReadLine(); 
    while (Line != null) {  
       Frames = Line.split(",");
       
       if (Frames[1] > v_evnt.ActiveTake.Offset.FrameCount && Frames[1] < (v_evnt.ActiveTake.Offset + v_evnt.Length).FrameCount) {
          Frame.FrameCount = Frames[1] - v_evnt.ActiveTake.Offset.FrameCount; 
          a_evnt = GetAudio(v_evnt); 
          evnt2 = v_evnt.Split(Frame);
          if (evnt2.IsGrouped) evnt2.Group.Remove(v_evnt);
          if (a_evnt) {
             evnt3 = a_evnt.Split(Frame); 
             if (evnt3.IsGrouped) evnt3.Group.Remove(a_evnt);
             NewGroup = new TrackEventGroup;
             Vegas.Project.Groups.Add(NewGroup); 
             NewGroup.Add(v_evnt);
             NewGroup.Add(a_evnt);  
          }
          v_evnt = evnt2;
       } 
       Line = Result.ReadLine(); 
    }
    
    Result.Close(); 
}

if (!Done) throw "No selected events";

} catch (e) {
  if (e != "EXIT")  MessageBox.Show(e, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);  
}

function GetAudio(video: TrackEvent): TrackEvent {
  if (video.IsGrouped) 
  for (var ev in video.Group) 
  if (!ev.Equals(video) &&
      (ev.Start + tolerance >= video.Start) && (ev.Start - tolerance <= video.Start) &&
      (ev.End + tolerance >= video.End) && (ev.End - tolerance <= video.End)  && 
      !ev.Track.Equals(video.Track) && 
      ev.MediaType != video.MediaType) return ev;
   
  return null;
}